OpenCV: cv::MatIterator_< _Tp > Class Template Reference

| OpenCV 3.4.2 Open Source Computer Vision

Public Types | Public Member Functions | List of all members
cv::MatIterator_< _Tp > Class Template Reference
Core functionality » Basic structures

Matrix read-write iterator. More...

`#include "mat.hpp"`

Inheritance diagram for cv::MatIterator_< _Tp >:

## Public Types
typedef std::random_access_iterator_tag | iterator_category
typedef _Tp * | pointer
typedef _Tp & | reference
Public Types inherited from cv::MatConstIterator_< _Tp >
typedef ptrdiff_t | difference_type
typedef std::random_access_iterator_tag | iterator_category
typedef const _Tp * | pointer
typedef const _Tp & | reference
typedef _Tp | value_type
Public Types inherited from cv::MatConstIterator
typedef ptrdiff_t | difference_type
typedef std::random_access_iterator_tag | iterator_category
typedef const uchar ** | pointer
typedef uchar * | reference
typedef uchar * | value_type

## Public Member Functions
| MatIterator_ ()
| the default constructor More...
| MatIterator_ (Mat_< _Tp > *_m)
| constructor that sets the iterator to the beginning of the matrix More...
| MatIterator_ (Mat_< _Tp > *_m, int _row, int _col=0)
| constructor that sets the iterator to the specified element of the matrix More...
| MatIterator_ (Mat_< _Tp > *_m, Point _pt)
| constructor that sets the iterator to the specified element of the matrix More...
| MatIterator_ (Mat_< _Tp > *_m, const int *_idx)
| constructor that sets the iterator to the specified element of the matrix More...
| MatIterator_ (const MatIterator_ &it)
| copy constructor More...
_Tp & | operator* () const
| returns the current matrix element More...
MatIterator_ & | operator++ ()
| increments the iterator More...
MatIterator_ | operator++ (int)
| increments the iterator More...
MatIterator_ & | operator+= (ptrdiff_t ofs)
| shifts the iterator forward by the specified number of elements More...
MatIterator_ & | operator-- ()
| decrements the iterator More...
MatIterator_ | operator-- (int)
| decrements the iterator More...
MatIterator_ & | operator-= (ptrdiff_t ofs)
| shifts the iterator backward by the specified number of elements More...
MatIterator_ & | operator= (const MatIterator_< _Tp > &it)
| copy operator More...
_Tp & | operator[] (ptrdiff_t i) const
| returns the i-th matrix element, relative to the current More...
Public Member Functions inherited from cv::MatConstIterator_< _Tp >
| MatConstIterator_ ()
| default constructor More...
| MatConstIterator_ (const Mat_< _Tp > *_m)
| constructor that sets the iterator to the beginning of the matrix More...
| MatConstIterator_ (const Mat_< _Tp > *_m, int _row, int _col=0)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator_ (const Mat_< _Tp > *_m, Point _pt)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator_ (const Mat_< _Tp > *_m, const int *_idx)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator_ (const MatConstIterator_ &it)
| copy constructor More...
const _Tp & | operator* () const
| returns the current matrix element More...
MatConstIterator_ & | operator++ ()
| increments the iterator More...
MatConstIterator_ | operator++ (int)
| increments the iterator More...
MatConstIterator_ & | operator+= (ptrdiff_t ofs)
| shifts the iterator forward by the specified number of elements More...
MatConstIterator_ & | operator-- ()
| decrements the iterator More...
MatConstIterator_ | operator-- (int)
| decrements the iterator More...
MatConstIterator_ & | operator-= (ptrdiff_t ofs)
| shifts the iterator backward by the specified number of elements More...
MatConstIterator_ & | operator= (const MatConstIterator_ &it)
| copy operator More...
const _Tp & | operator[] (ptrdiff_t i) const
| returns the i-th matrix element, relative to the current More...
Point | pos () const
| returns the current iterator position More...
Public Member Functions inherited from cv::MatConstIterator
| MatConstIterator ()
| default constructor More...
| MatConstIterator (const Mat *_m)
| constructor that sets the iterator to the beginning of the matrix More...
| MatConstIterator (const Mat *_m, int _row, int _col=0)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator (const Mat *_m, Point _pt)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator (const Mat *_m, const int *_idx)
| constructor that sets the iterator to the specified element of the matrix More...
| MatConstIterator (const MatConstIterator &it)
| copy constructor More...
ptrdiff_t | lpos () const
const uchar * | operator* () const
| returns the current matrix element More...
MatConstIterator & | operator++ ()
| increments the iterator More...
MatConstIterator | operator++ (int)
| increments the iterator More...
MatConstIterator & | operator+= (ptrdiff_t ofs)
| shifts the iterator forward by the specified number of elements More...
MatConstIterator & | operator-- ()
| decrements the iterator More...
MatConstIterator | operator-- (int)
| decrements the iterator More...
MatConstIterator & | operator-= (ptrdiff_t ofs)
| shifts the iterator backward by the specified number of elements More...
MatConstIterator & | operator= (const MatConstIterator &it)
| copy operator More...
const uchar * | operator[] (ptrdiff_t i) const
| returns the i-th matrix element, relative to the current More...
Point | pos () const
| returns the current iterator position More...
void | pos (int *_idx) const
| returns the current iterator position More...
void | seek (ptrdiff_t ofs, bool relative=false)
void | seek (const int *_idx, bool relative=false)

## Additional Inherited Members
Public Attributes inherited from cv::MatConstIterator
size_t | elemSize
const Mat * | m
const uchar * | ptr
const uchar * | sliceEnd
const uchar * | sliceStart

## Detailed Description

### template<typename _Tp>
class cv::MatIterator_< _Tp >

Matrix read-write iterator.

## Member Typedef Documentation

## ◆ iterator_category

template<typename _Tp>

typedef std::random_access_iterator_tag cv::MatIterator_< _Tp >::iterator_category

## ◆ pointer

template<typename _Tp>

typedef _Tp* cv::MatIterator_< _Tp >::pointer

## ◆ reference

template<typename _Tp>

typedef _Tp& cv::MatIterator_< _Tp >::reference

## Constructor & Destructor Documentation

## ◆ MatIterator_() [1/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( |  | ) |

the default constructor

## ◆ MatIterator_() [2/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( | Mat_< _Tp > * | _m | ) |

constructor that sets the iterator to the beginning of the matrix

## ◆ MatIterator_() [3/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( | Mat_< _Tp > * | _m,
|  | int | _row,
|  | int | _col = `0`
| ) |  |

constructor that sets the iterator to the specified element of the matrix

## ◆ MatIterator_() [4/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( | Mat_< _Tp > * | _m,
|  | Point | _pt
| ) |  |

constructor that sets the iterator to the specified element of the matrix

## ◆ MatIterator_() [5/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( | Mat_< _Tp > * | _m,
|  | const int * | _idx
| ) |  |

constructor that sets the iterator to the specified element of the matrix

## ◆ MatIterator_() [6/6]

template<typename _Tp>

cv::MatIterator_< _Tp >::MatIterator_ | ( | const MatIterator_< _Tp > & | it | ) |

copy constructor

## Member Function Documentation

## ◆ operator*()

template<typename _Tp>

_Tp& cv::MatIterator_< _Tp >::operator* | ( |  | ) | const

returns the current matrix element

## ◆ operator++() [1/2]

template<typename _Tp>

MatIterator_& cv::MatIterator_< _Tp >::operator++ | ( |  | ) |

increments the iterator

## ◆ operator++() [2/2]

template<typename _Tp>

MatIterator_ cv::MatIterator_< _Tp >::operator++ | ( | int |  | ) |

increments the iterator

## ◆ operator+=()

template<typename _Tp>

MatIterator_& cv::MatIterator_< _Tp >::operator+= | ( | ptrdiff_t | ofs | ) |

shifts the iterator forward by the specified number of elements

## ◆ operator--() [1/2]

template<typename _Tp>

MatIterator_& cv::MatIterator_< _Tp >::operator-- | ( |  | ) |

decrements the iterator

## ◆ operator--() [2/2]

template<typename _Tp>

MatIterator_ cv::MatIterator_< _Tp >::operator-- | ( | int |  | ) |

decrements the iterator

## ◆ operator-=()

template<typename _Tp>

MatIterator_& cv::MatIterator_< _Tp >::operator-= | ( | ptrdiff_t | ofs | ) |

shifts the iterator backward by the specified number of elements

## ◆ operator=()

template<typename _Tp>

MatIterator_& cv::MatIterator_< _Tp >::operator= | ( | const MatIterator_< _Tp > & | it | ) |

copy operator

## ◆ operator[]()

template<typename _Tp>

_Tp& cv::MatIterator_< _Tp >::operator[] | ( | ptrdiff_t | i | ) | const

returns the i-th matrix element, relative to the current

The documentation for this class was generated from the following file:

- core/include/opencv2/core/mat.hpp